/*============================================================================
	File: Debug.sql 

	Summary: These scripts show a bogus deadlock
	
	Read instructions.txt
	
	Based on an example from James Rowland-Jones
	http://blogs.conchango.com/jamesrowlandjones/archive/2009/05/28/the-curious-case-of-the-dubious-deadlock-and-the-not-so-logical-lock.aspx 

	Date: October 2010 

	SQL Server Versions:
		10.0.2531.00 (SS2008 SP1)
		9.00.4035.00 (SS2005 SP3)
------------------------------------------------------------------------------
	Copyright (C) 2010 Paul S. Randal, SQLskills.com
	All rights reserved. 

	For more scripts and sample code, check out
		http://www.sqlskills.com/ 

	You may alter this code for your own *non-commercial* purposes. You may
	republish altered code as long as you give due credit. 

	THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF
	ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED
	TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
	PARTICULAR PURPOSE.
============================================================================*/ 

-- How can they have the same lock resource?
-- Let's see...
USE LockResDemo;
GO

CREATE TABLE TmpLockResCheck (
	[Date]		DATETIME,
	CountryID	TINYINT,
	GroupID		SMALLINT,
	CodeID		INT);
GO

INSERT INTO TmpLockResCheck
VALUES ('20090519', 3, 4245, 2651987);
GO
INSERT INTO TmpLockResCheck
VALUES ('20090519', 3, 4657, 5744053);
GO

INSERT INTO TmpLockResCheck
VALUES ('20090519', 2, 4271, 5835066);
GO
INSERT INTO TmpLockResCheck
VALUES ('20090519', 2, 4619, 2546652);
GO

CREATE UNIQUE CLUSTERED INDEX TmpLockResCheck_PK 
ON TmpLockResCheck ([date], CountryID, GroupID, CodeID);
GO

SELECT %%lockres%%, * FROM TmpLockResCheck;
GO
